WhiteColourInsteadInPlay = function()
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone( ZONE_IN_PLAY )
  filter:SetPlayer( Object():GetPlayer() )
  filter:AddCardName( "ARCTIC_AVEN" )
  filter:AddCardName( "ARCTIC_NISHOBA" )
  filter:AddCardName( "AURIOK_REPLICA" )
  filter:AddCardName( "AZORIUS_KEYRUNE" )
  filter:AddCardName( "BLADED_SENTINEL" )
  filter:AddCardName( "BLINDING_SOULEATER" )
  filter:AddCardName( "BOROS_KEYRUNE" )
  filter:AddCardName( "CLOUDHEATH_DRAKE" )
  filter:AddCardName( "CROWN_OF_CONVERGENCE" )
  filter:AddCardName( "CYLIAN_SUNSINGER" )
  filter:AddCardName( "DAUGHTER_OF_AUTUMN" )
  filter:AddCardName( "DAWNRAY_ARCHER" )
  filter:AddCardName( "ESPER_BATTLEMAGE" )
  filter:AddCardName( "ETHERSWORN_ADJUDICATOR" )
  filter:AddCardName( "GLINT_HAWK_IDOL" )
  filter:AddCardName( "GODTOUCHER" )
  filter:AddCardName( "GRANGER_GUILDMAGE" )
  filter:AddCardName( "HEALERS_HEADDRESS" )
  filter:AddCardName( "HEDGE_TROLL" )
  filter:AddCardName( "KAVU_GLIDER" )
  filter:AddCardName( "KRANIOCEROS" )
  filter:AddCardName( "LEONIN_SUN_STANDARD" )
  filter:AddCardName( "LLANOWAR_CAVALRY" )
  filter:AddCardName( "MIRROR_WALL" )
  filter:AddCardName( "MIRRORWOOD_TREEFOLK" )
  filter:AddCardName( "MORATORIUM_STONE" )
  filter:AddCardName( "MOURNFUL_ZOMBIE" )
  filter:AddCardName( "NAYA_BATTLEMAGE" )
  filter:AddCardName( "NECRA_DISCIPLE" )
  filter:AddCardName( "OCULAR_HALO" )
  filter:AddCardName( "ORDRUUN_COMMANDO" )
  filter:AddCardName( "ORIGIN_SPELLBOMB" )
  filter:AddCardName( "ORZHOV_KEYRUNE" )
  filter:AddCardName( "OSTIARY_THRULL" )
  filter:AddCardName( "PROTOMATTER_POWDER" )
  filter:AddCardName( "RAKA_DISCIPLE" )
  filter:AddCardName( "SACELLUM_ARCHERS" )
  filter:AddCardName( "SCORNFUL_AETHERLICH" )
  filter:AddCardName( "SELESNYA_KEYRUNE" )
  filter:AddCardName( "SHAPER_GUILDMAGE" )
  filter:AddCardName( "SOLDIER_REPLICA" )
  filter:AddCardName( "SOLDEVI_HERETIC" )
  filter:AddCardName( "STONE_KAVU" )
  filter:AddCardName( "STORMSCAPE_APPRENTICE" )
  filter:AddCardName( "STORMSCAPE_MASTER" )
  filter:AddCardName( "SUNBEAM_SPELLBOMB" )
  filter:AddCardName( "SUNFORGER" )
  filter:AddCardName( "THORNSCAPE_APPRENTICE" )
  filter:AddCardName( "THORNSCAPE_MASTER" )
  filter:AddCardName( "THUNDER_TOTEM" )
  filter:AddCardName( "TITANIUM_GOLEM" )
  filter:AddCardName( "TOWER_DRAKE" )
  filter:AddCardName( "TOWERING_THUNDERFIST" )
  filter:AddCardName( "TRANSLUMINANT" )
  filter:AddCardName( "TREEFOLK_HEALER" )
  filter:AddCardName( "TRIGON_OF_MENDING" )
  filter:AddCardName( "WALKING_ARCHIVE" )
  filter:AddCardName( "WHIPSPINE_DRAKE" )
  filter:AddCardName( "WILD_RESEARCH" )
  filter:AddCardName( "CELESTIAL_COLONNADE" )
  filter:AddCardName( "DARU_ENCAMPMENT" )
  filter:AddCardName( "EIGANJO_CASTLE" )
  filter:AddCardName( "FETID_HEATH" )
  filter:AddCardName( "FORBIDDING_WATCHTOWER" )
  filter:AddCardName( "GAVONY_TOWNSHIP" )
  filter:AddCardName( "GROVE_OF_THE_GUARDIAN" )
  filter:AddCardName( "KJELDORAN_OUTPOST" )
  filter:AddCardName( "KOR_HAVEN" )
  filter:AddCardName( "MISTVEIL_PLAINS" )
  filter:AddCardName( "MOORLAND_HAUNT" )
  filter:AddCardName( "MYSTIC_GATE" )
  filter:AddCardName( "NANTUKO_MONASTERY" )
  filter:AddCardName( "NOMAD_STADIUM" )
  filter:AddCardName( "ORZHOVA_THE_CHURCH_OF_DEALS" )
  filter:AddCardName( "PRAHV_SPIRES_OF_ORDER" )
  filter:AddCardName( "RUGGED_PRAIRIE" )
  filter:AddCardName( "SEASIDE_HAVEN" )
  filter:AddCardName( "SLAYERS_STRONGHOLD" )
  filter:AddCardName( "STARLIT_SANCTUM" )
  filter:AddCardName( "STIRRING_WILDWOOD" )
  filter:AddCardName( "SUNHOME_FORTRESS_OF_THE_LEGION" )
  filter:AddCardName( "VAULT_OF_THE_ARCHANGEL" )
  filter:AddCardName( "VITUGHAZI_THE_CITYTREE" )
  filter:AddCardName( "WINDBRISK_HEIGHTS" )
  filter:AddCardName( "WOODED_BASTION" )
  return filter:CountStopAt( 1 )
end

WhiteColourInstead = function()
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone( ZONE_ANYWHERE )
  filter:SetPlayer( Object():GetPlayer() )
  filter:AddCardName( "BURNING_OIL" )
  filter:AddCardName( "COURT_HUSSAR" )
  filter:AddCardName( "DESOLATION_ANGEL" )
  filter:AddCardName( "DESOLATION_GIANT" )
  filter:AddCardName( "DRYADS_CARESS" )
  filter:AddCardName( "FLASH_CONSCRIPTION" ) 
  filter:AddCardName( "FOLK_MEDICINE" )
  filter:AddCardName( "NECRAVOLVER" )
  filter:AddCardName( "RAKAVOLVER" )
  filter:AddCardName( "REVENANT_PATRIARCH" )
  filter:AddCardName( "RESOUNDING_ROAR" )
  filter:AddCardName( "RESOUNDING_WAVE" )
  filter:AddCardName( "SAVING_GRASP" )
  filter:AddCardName( "STORMSCAPE_BATTLEMAGE" )
  filter:AddCardName( "THORNSCAPE_BATTLEMAGE" )
  filter:AddCardName( "THRILL_OF_THE_HUNT" )
  filter:AddCardName( "TOLARIAN_EMISSARY" )
  filter:AddCardName( "TRAVEL_PREPARATIONS" )
  filter:AddCardName( "UNBURIAL_RITES" )
  filter:AddCardName( "VIGOROUS_CHARGE" )
  filter:AddCardName( "RUSTIC_CLACHAN" )
  filter:AddCardName( "SECLUDED_STEPPE" )
  return filter:CountStopAt( 1 )
end

BlueColourInsteadInPlay = function()
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone( ZONE_IN_PLAY )
  filter:SetPlayer( Object():GetPlayer() )
  filter:AddCardName( "AERIE_MYSTICS" )
  filter:AddCardName( "AETHER_SPELLBOMB" )
  filter:AddCardName( "ANA_DISCIPLE" )
  filter:AddCardName( "ARENSONS_AURA" )
  filter:AddCardName( "AZORIUS_KEYRUNE" )
  filter:AddCardName( "BANT_BATTLEMAGE" )
  filter:AddCardName( "BENALISH_HERALDS" )
  filter:AddCardName( "BLOODLETTER_QUILL" )
  filter:AddCardName( "BRINE_SHAMAN" )
  filter:AddCardName( "CHRONATOG_TOTEM" )
  filter:AddCardName( "CIVIC_GUILDMAGE" )
  filter:AddCardName( "COBALT_GOLEM" )
  filter:AddCardName( "CRYSTAL_SHARD" )
  filter:AddCardName( "DIMIR_KEYRUNE" )
  filter:AddCardName( "DISCIPLE_OF_KANGEE" )
  filter:AddCardName( "DREADWING" )
  filter:AddCardName( "EVOLUTION_VAT" )
  filter:AddCardName( "FLIGHT_SPELLBOMB" )
  filter:AddCardName( "GLIMMERING_ANGEL" )
  filter:AddCardName( "GRIXIS_BATTLEMAGE" )
  filter:AddCardName( "GUSTSKIMMER" )
  filter:AddCardName( "HARBOR_BANDIT" )
  filter:AddCardName( "HORROR_OF_THE_DIM" )
  filter:AddCardName( "HYPERVOLT_GRASP" )
  filter:AddCardName( "IZZET_KEYRUNE" )
  filter:AddCardName( "JOTUN_OWL_KEEPER" )
  filter:AddCardName( "KAVU_GLIDER" )
  filter:AddCardName( "KJELDORAN_PRIDE" )
  filter:AddCardName( "KROVIKAN_ELEMENTALIST" )
  filter:AddCardName( "MEMNARCH" )
  filter:AddCardName( "MIZZIUM_TRANSRELIQUAT" )
  filter:AddCardName( "NEUROK_REPLICA" )
  filter:AddCardName( "NEUROK_STEALTHSUIT" )
  filter:AddCardName( "NIGHTSCAPE_APPRENTICE" )
  filter:AddCardName( "NIGHTSCAPE_MASTER" )
  filter:AddCardName( "PHANTASMAL_FIEND" )
  filter:AddCardName( "PHYREXIAN_INFILTRATOR" )
  filter:AddCardName( "PROTEUS_STAFF" )
  filter:AddCardName( "PUPPET_CONJURER" )
  filter:AddCardName( "PURSUIT_OF_FLIGHT" )
  filter:AddCardName( "RAKA_DISCIPLE" )
  filter:AddCardName( "ROOFSTALKER_WIGHT" )
  filter:AddCardName( "SAVAGE_GORILLA" )
  filter:AddCardName( "SHADOW_GUILDMAGE" )
  filter:AddCardName( "SHORE_SNAPPER" )
  filter:AddCardName( "SIGHTEDCASTE_SORCERER" )
  filter:AddCardName( "SIMIC_KEYRUNE" )
  filter:AddCardName( "SIMIC_RAGWORM" )
  filter:AddCardName( "SOLITON" )
  filter:AddCardName( "SOULSWORN_JURY" )
  filter:AddCardName( "SPELLSKITE" )
  filter:AddCardName( "SUNSCAPE_APPRENTICE" )
  filter:AddCardName( "SUNSCAPE_MASTER" )
  filter:AddCardName( "TEFERIS_CARE" )
  filter:AddCardName( "TEFERIS_HONOR_GUARD" )
  filter:AddCardName( "THELONS_CURSE" )
  filter:AddCardName( "TRESPASSING_SOULEATER" )
  filter:AddCardName( "TRIGON_OF_THOUGHT" )
  filter:AddCardName( "URBORG_PHANTOM" )
  filter:AddCardName( "WALKING_ARCHIVE" )
  filter:AddCardName( "WILD_RESEARCH" )
  filter:AddCardName( "WIZARD_REPLICA" )
  filter:AddCardName( "ACADEMY_RUINS" )
  filter:AddCardName( "ALCHEMISTS_REFUGE" )
  filter:AddCardName( "CASCADE_BLUFFS" )
  filter:AddCardName( "CELESTIAL_COLONNADE" )
  filter:AddCardName( "CEPHALID_COLISEUM" )
  filter:AddCardName( "CREEPING_TAR_PIT" )
  filter:AddCardName( "DESOLATE_LIGHTHOUSE" )
  filter:AddCardName( "DUSKMANTLE_HOUSE_OF_SHADOW" )
  filter:AddCardName( "FAERIE_CONCLAVE" )
  filter:AddCardName( "FLOODED_GROVE" )
  filter:AddCardName( "MAGOSI_THE_WATERVEIL" )
  filter:AddCardName( "MINAMO_SCHOOL_AT_WATERS_EDGE" )
  filter:AddCardName( "MOONRING_ISLAND" )
  filter:AddCardName( "MOORLAND_HAUNT" )
  filter:AddCardName( "MYSTIC_GATE" )
  filter:AddCardName( "NEPHALIA_DROWNYARD" )
  filter:AddCardName( "NIVIX_AERIE_OF_THE_FIREMIND" )
  filter:AddCardName( "NOVIJEN_HEART_OF_PROGRESS" )
  filter:AddCardName( "PRAHV_SPIRES_OF_ORDER" )
  filter:AddCardName( "RIPTIDE_LABORATORY" )
  filter:AddCardName( "SEASIDE_HAVEN" )
  filter:AddCardName( "SHELLDOCK_ISLE" )
  filter:AddCardName( "SUNKEN_RUINS" )
  return filter:CountStopAt( 1 )
end

BlueColourInstead = function()
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone( ZONE_ANYWHERE )
  filter:SetPlayer( Object():GetPlayer() )
  filter:AddCardName( "ANA_BATTLEMAGE" )
  filter:AddCardName( "ANAVOLVER" )
  filter:AddCardName( "AZORIUS_HERALD" )
  filter:AddCardName( "DESPERATE_RAVINGS" )
  filter:AddCardName( "DISMANTLING_BLOW" )
  filter:AddCardName( "FEELING_OF_DREAD" )
  filter:AddCardName( "ILLUMINATE" )
  filter:AddCardName( "MOMENTARY_BLINK" )
  filter:AddCardName( "NIGHTSCAPE_BATTLEMAGE" )
  filter:AddCardName( "OGRE_SAVANT" )
  filter:AddCardName( "PATAGIA_VIPER" )
  filter:AddCardName( "QUENCHABLE_FIRE" )
  filter:AddCardName( "RAKAVOLVER" )
  filter:AddCardName( "REAP_THE_SEAGRAF" )
  filter:AddCardName( "RESOUNDING_SCREAM" )
  filter:AddCardName( "RESOUNDING_SILENCE" )
  filter:AddCardName( "RIBBONS_OF_NIGHT" )  
  filter:AddCardName( "SUNSCAPE_BATTLEMAGE" )
  filter:AddCardName( "TRACKERS_INSTINCTS" )
  filter:AddCardName( "URBORG_EMISSARY" )
  filter:AddCardName( "LONELY_SANDBAR" )
  filter:AddCardName( "TOLARIA_WEST" )
  return filter:CountStopAt( 1 )
end

BlueColourInsteadOpponent = function()
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone( ZONE_ANYWHERE )
  filter:SetControllersTeam( Object():GetPlayer():GetTeam() )
  filter:AddExtra( FILTER_EXTRA_FLIP_TEAM )
  filter:AddCardName( "QUENCHABLE_FIRE" )
  filter:AddCardName( "MTENDA_LION" )
  return filter:CountStopAt( 1 )
end

BlackColourInsteadInPlay = function()
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone( ZONE_IN_PLAY )
  filter:SetPlayer( Object():GetPlayer() )
  filter:AddCardName( "ANA_DISCIPLE" )
  filter:AddCardName( "ARMORER_GUILDMAGE" )
  filter:AddCardName( "BALSHAN_COLLABORATOR" )
  filter:AddCardName( "BLOODLETTER_QUILL" )
  filter:AddCardName( "BONE_SHAMAN" )
  filter:AddCardName( "CALDERA_KAVU" )
  filter:AddCardName( "CRANIAL_PLATING" )
  filter:AddCardName( "CRIMSON_MUCKWADER" )
  filter:AddCardName( "DARKLIT_GARGOYLE" )
  filter:AddCardName( "DEGA_DISCIPLE" )
  filter:AddCardName( "DIMIR_KEYRUNE" )
  filter:AddCardName( "DROWNED" )
  filter:AddCardName( "DROSS_RIPPER" )
  filter:AddCardName( "DUTIFUL_THRULL" )
  filter:AddCardName( "ESPER_BATTLEMAGE" )
  filter:AddCardName( "ETHERIUM_ASTROLABE" )
  filter:AddCardName( "ETHERSWORN_ADJUDICATOR" )
  filter:AddCardName( "GOLGARI_KEYRUNE" )
  filter:AddCardName( "HENCHFIEND_OF_UKOR" )
  filter:AddCardName( "HEX_PARASITE" )
  filter:AddCardName( "HOODED_KAVU" )
  filter:AddCardName( "JUND_BATTLEMAGE" )
  filter:AddCardName( "KELDON_MANTLE" )
  filter:AddCardName( "KILLSUIT_CULTIST" )
  filter:AddCardName( "KROVIKAN_WHISPERS" )
  filter:AddCardName( "LASHWRITHE" )
  filter:AddCardName( "MANACLES_OF_DECAY" )
  filter:AddCardName( "METATHRAN_ZOMBIE" )
  filter:AddCardName( "MORATORIUM_STONE" )
  filter:AddCardName( "MORIOK_REPLICA" )
  filter:AddCardName( "NECROGEN_SPELLBOMB" )
  filter:AddCardName( "NIHIL_SPELLBOMB" )
  filter:AddCardName( "NIM_REPLICA" )
  filter:AddCardName( "ORCISH_HEALER" )
  filter:AddCardName( "ORZHOV_KEYRUNE" )
  filter:AddCardName( "PARDIC_COLLABORATOR" )
  filter:AddCardName( "PESTILENT_SOULEATER" )
  filter:AddCardName( "PEWTER_GOLEM" )
  filter:AddCardName( "PHYREXIAN_TOTEM" )
  filter:AddCardName( "PLAGUE_BOILER" )
  filter:AddCardName( "POSSESSED_AVEN" )
  filter:AddCardName( "POSSESSED_BARBARIAN" )
  filter:AddCardName( "POSSESSED_CENTAUR" )
  filter:AddCardName( "POSSESSED_NOMAD" )
  filter:AddCardName( "RAKDOS_KEYRUNE" )
  filter:AddCardName( "RAKDOS_RITEKNIFE" )
  filter:AddCardName( "RHYS_THE_EXILED" )
  filter:AddCardName( "SAVAGE_GORILLA" )
  filter:AddCardName( "SCORNFUL_AETHERLICH" )
  filter:AddCardName( "SEDGE_SLIVER" )
  filter:AddCardName( "SEDGE_TROLL" )
  filter:AddCardName( "SHADOW_LANCE" )
  filter:AddCardName( "SHAPER_GUILDMAGE" )
  filter:AddCardName( "SKELETON_SHARD" )
  filter:AddCardName( "SPECTRAL_LYNX" )
  filter:AddCardName( "STONEFARE_CROCODILE" )
  filter:AddCardName( "STORMSCAPE_APPRENTICE" )
  filter:AddCardName( "STORMSCAPE_MASTER" )
  filter:AddCardName( "TATTERED_DRAKE" )
  filter:AddCardName( "THELON_OF_HAVENWOOD" )
  filter:AddCardName( "THUNDERSCAPE_APPRENTICE" )
  filter:AddCardName( "THUNDERSCAPE_MASTER" )
  filter:AddCardName( "TRIBAL_GOLEM" )
  filter:AddCardName( "TRIGON_OF_CORRUPTION" )
  filter:AddCardName( "VECTIS_SILENCERS" )
  filter:AddCardName( "VECTOR_ASP" )
  filter:AddCardName( "VIASHINO_SKELETON" )
  filter:AddCardName( "VIASHINO_SLAUGHTERMASTER" )
  filter:AddCardName( "VODALIAN_HYPNOTIST" )
  filter:AddCardName( "WORMWOOD_DRYAD" )
  filter:AddCardName( "WORMWOOD_TREEFOLK" )
  filter:AddCardName( "ZURAN_ENCHANTER" )
  filter:AddCardName( "CABAL_PIT" )
  filter:AddCardName( "CREEPING_TAR_PIT" )
  filter:AddCardName( "DUSKMANTLE_HOUSE_OF_SHADOW" )
  filter:AddCardName( "FETID_HEATH" )
  filter:AddCardName( "GRAVEN_CAIRNS" )
  filter:AddCardName( "GRIM_BACKWOODS" )
  filter:AddCardName( "HOWLTOOTH_HOLLOW" )
  filter:AddCardName( "LAVACLAW_REACHES" )
  filter:AddCardName( "LEECHRIDDEN_SWAMP" )
  filter:AddCardName( "NEPHALIA_DROWNYARD" )
  filter:AddCardName( "ORZHOVA_THE_CHURCH_OF_DEALS" )
  filter:AddCardName( "RIX_MAADI_DUNGEON_PALACE" )
  filter:AddCardName( "SHIZO_DEATHS_STOREHOUSE" )
  filter:AddCardName( "SPAWNING_POOL" )
  filter:AddCardName( "STARLIT_SANCTUM" )
  filter:AddCardName( "STENSIA_BLOODHALL" )
  filter:AddCardName( "SUNKEN_RUINS" )
  filter:AddCardName( "SVOGTHOS_THE_RESTLESS_TOMB" )
  filter:AddCardName( "TOMB_OF_URAMI" )
  filter:AddCardName( "TWILIGHT_MIRE" )
  filter:AddCardName( "UNHOLY_GROTTO" )
  filter:AddCardName( "VAULT_OF_THE_ARCHANGEL" )
  filter:AddCardName( "VOLRATHS_STRONGHOLD" )
  return filter:CountStopAt( 1 )
end

BlackColourInstead = function()
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone( ZONE_ANYWHERE )
  filter:SetPlayer( Object():GetPlayer() )
  filter:AddCardName( "ANA_BATTLEMAGE" )
  filter:AddCardName( "ANAVOLVER" )
  filter:AddCardName( "DEGAVOLVER" )
  filter:AddCardName( "DRALNUS_PET" )
  filter:AddCardName( "FIRES_OF_UNDEATH" )
  filter:AddCardName( "FORBIDDEN_ALCHEMY" )
  filter:AddCardName( "INDUCE_PARANOIA" )
  filter:AddCardName( "LINGERING_SOULS" )
  filter:AddCardName( "MYSTICAL_TEACHINGS" )
  filter:AddCardName( "PROBE" )
  filter:AddCardName( "RESOUNDING_THUNDER" )
  filter:AddCardName( "RESOUNDING_WAVE" )
  filter:AddCardName( "ROLLING_SPOIL" )
  filter:AddCardName( "SHIVAN_EMISSARY" )
  filter:AddCardName( "SHRIEKING_GROTESQUE" )
  filter:AddCardName( "SKELETONIZE" )
  filter:AddCardName( "SPIDER_SPAWNING" )
  filter:AddCardName( "SQUEALING_DEVIL" )
  filter:AddCardName( "STORMSCAPE_BATTLEMAGE" )
  filter:AddCardName( "STRENGTH_OF_NIGHT" )
  filter:AddCardName( "THUNDERSCAPE_BATTLEMAGE" )
  filter:AddCardName( "BARREN_MOOR" )
  return filter:CountStopAt( 1 )
end

RedColourInsteadInPlay = function()
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone( ZONE_IN_PLAY )
  filter:SetPlayer( Object():GetPlayer() )
  filter:AddCardName( "ANGELFIRE_CRUSADER" )
  filter:AddCardName( "BALDUVIAN_DEAD" )
  filter:AddCardName( "BALDUVIAN_FALLEN" )
  filter:AddCardName( "BOROS_KEYRUNE" )
  filter:AddCardName( "BOSH_IRON_GOLEM" )
  filter:AddCardName( "CAVERN_THOCTAR" )
  filter:AddCardName( "CETA_DISCIPLE" )
  filter:AddCardName( "CYLIAN_SUNSINGER" )
  filter:AddCardName( "DEGA_DISCIPLE" )
  filter:AddCardName( "DEVIANT_GLEE" )
  filter:AddCardName( "DISCIPLE_OF_THE_OLD_WAYS" )
  filter:AddCardName( "DREADWING" )
  filter:AddCardName( "ELECTRIC_EEL" )
  filter:AddCardName( "FIRESCREAMER" )
  filter:AddCardName( "FLINTHOOF_BOAR" )
  filter:AddCardName( "FORIYSIAN_TOTEM" )
  filter:AddCardName( "GOBLIN_REPLICA" )
  filter:AddCardName( "GRANGER_GUILDMAGE" )
  filter:AddCardName( "GRANITE_SHARD" )
  filter:AddCardName( "GRIXIS_BATTLEMAGE" )
  filter:AddCardName( "GRUUL_KEYRUNE" )
  filter:AddCardName( "GRUUL_NODOROG" )
  filter:AddCardName( "GRUUL_WAR_PLOW" )
  filter:AddCardName( "HEMATITE_GOLEM" )
  filter:AddCardName( "IMMOLATING_SOULEATER" )
  filter:AddCardName( "IZZET_KEYRUNE" )
  filter:AddCardName( "KROVIKAN_ELEMENTALIST" )
  filter:AddCardName( "MANACLES_OF_DECAY" )
  filter:AddCardName( "MIRRORWOOD_TREEFOLK" )
  filter:AddCardName( "MIZZIUM_TRANSRELIQUAT" )
  filter:AddCardName( "NACATL_HUNTPRIDE" )
  filter:AddCardName( "NAYA_BATTLEMAGE" )
  filter:AddCardName( "NETTLING_CURSE" )
  filter:AddCardName( "NIGHTFALL_PREDATOR" )
  filter:AddCardName( "NIGHTSCAPE_APPRENTICE" )
  filter:AddCardName( "NIGHTSCAPE_MASTER" )
  filter:AddCardName( "PANIC_SPELLBOMB" )
  filter:AddCardName( "PESTILENT_KATHARI" )
  filter:AddCardName( "PYRITE_SPELLBOMB" )
  filter:AddCardName( "RAKDOS_KEYRUNE" )
  filter:AddCardName( "RAKDOS_RITEKNIFE" )
  filter:AddCardName( "SABERCLAW_GOLEM" )
  filter:AddCardName( "SACELLUM_ARCHERS" )
  filter:AddCardName( "SCREECHING_GRIFFIN" )
  filter:AddCardName( "SERPENTINE_KAVU" )
  filter:AddCardName( "SHADOW_GUILDMAGE" )
  filter:AddCardName( "SHAMBLING_STRIDER" )
  filter:AddCardName( "SPARRING_COLLAR" )
  filter:AddCardName( "SPIN_ENGINE" )
  filter:AddCardName( "STEAM_SPITTER" )
  filter:AddCardName( "STONE_KAVU" )
  filter:AddCardName( "STORMCLOUD_DJINN" )
  filter:AddCardName( "SUNFORGER" )
  filter:AddCardName( "THORNSCAPE_APPRENTICE" )
  filter:AddCardName( "THORNSCAPE_MASTER" )
  filter:AddCardName( "TINDER_WALL" )
  filter:AddCardName( "TORCH_DRAKE" )
  filter:AddCardName( "TRENCH_WURM" )
  filter:AddCardName( "TRIGON_OF_RAGE" )
  filter:AddCardName( "UNDEAD_LEOTAU" )
  filter:AddCardName( "VEIN_DRINKER" )
  filter:AddCardName( "VOLCANO_IMP" )
  filter:AddCardName( "VULSHOK_REPLICA" )
  filter:AddCardName( "WHIRLPOOL_WARRIOR" )
  filter:AddCardName( "BARBARIAN_RING" )
  filter:AddCardName( "CASCADE_BLUFFS" )
  filter:AddCardName( "CONTESTED_CLIFFS" )
  filter:AddCardName( "DESOLATE_LIGHTHOUSE" )
  filter:AddCardName( "FIRELIT_THICKET" )
  filter:AddCardName( "GHITU_ENCAMPMENT" )
  filter:AddCardName( "GOBLIN_BURROWS" )
  filter:AddCardName( "GRAVEN_CAIRNS" )
  filter:AddCardName( "HELLION_CRUCIBLE" )
  filter:AddCardName( "KELDON_MEGALITHS" )
  filter:AddCardName( "KELDON_NECROPOLIS" )
  filter:AddCardName( "KHER_KEEP" )
  filter:AddCardName( "KESSIG_WOLF_RUN" )
  filter:AddCardName( "LAVACLAW_REACHES" )
  filter:AddCardName( "MADBLIND_MOUNTAIN" )
  filter:AddCardName( "NIVIX_AERIE_OF_THE_FIREMIND" )
  filter:AddCardName( "RAGING_RAVINE" )
  filter:AddCardName( "RIX_MAADI_DUNGEON_PALACE" )
  filter:AddCardName( "RUGGED_PRAIRIE" )
  filter:AddCardName( "SHINKA_THE_BLOODSOAKED_KEEP" )
  filter:AddCardName( "SHIVAN_GORGE" )
  filter:AddCardName( "SKARRG_THE_RAGE_PITS" )
  filter:AddCardName( "SLAYERS_STRONGHOLD" )
  filter:AddCardName( "SPINEROCK_KNOLL" )
  filter:AddCardName( "STENSIA_BLOODHALL" )
  filter:AddCardName( "SUNHOME_FORTRESS_OF_THE_LEGION" )
  return filter:CountStopAt( 1 )
end

RedColourInstead = function()
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone( ZONE_ANYWHERE )
  filter:SetPlayer( Object():GetPlayer() )
  filter:AddCardName( "AGONIZING_DEMISE" )
  filter:AddCardName( "BOROS_FURYSHIELD" )
  filter:AddCardName( "BUMP_IN_THE_NIGHT" )
  filter:AddCardName( "CETAVOLVER" )
  filter:AddCardName( "CRYPT_CHAMPION" )
  filter:AddCardName( "DEGAVOLVER" )
  filter:AddCardName( "GRUUL_SCRAPPER" )
  filter:AddCardName( "JILT" )
  filter:AddCardName( "MYSTIC_RETRIEVAL" )
  filter:AddCardName( "NIGHTSCAPE_BATTLEMAGE" )
  filter:AddCardName( "ORIMS_THUNDER" )
  filter:AddCardName( "RALLY_THE_PEASANTS" )
  filter:AddCardName( "RESOUNDING_ROAR" )
  filter:AddCardName( "RESOUNDING_SCREAM" )
  filter:AddCardName( "STEAMCORE_WEIRD" )
  filter:AddCardName( "STRANGLING_SOOT" )
  filter:AddCardName( "THORNSCAPE_BATTLEMAGE" )
  filter:AddCardName( "UNDERGROWTH" )
  filter:AddCardName( "VERDURAN_EMISSARY" )
  filter:AddCardName( "WILD_HUNGER" )
  filter:AddCardName( "FORGOTTEN_CAVE" )
  return filter:CountStopAt( 1 )
end

RedColourInsteadOpponent = function()
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone( ZONE_IN_PLAY )
  filter:SetControllersTeam( Object():GetPlayer():GetTeam() )
  filter:AddExtra( FILTER_EXTRA_FLIP_TEAM )
  filter:AddCardName( "HEROISM" )
  return filter:CountStopAt( 1 )
end

RedColourInsteadPlane = function()
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone( ZONE_ANYWHERE )
  filter:AddCardName( "SHIV" )
  return filter:CountStopAt( 1 )
end

GreenColourInsteadInPlay = function()
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone( ZONE_IN_PLAY )
  filter:SetPlayer( Object():GetPlayer() )
  filter:AddCardName( "AERIE_MYSTICS" )
  filter:AddCardName( "ARMORER_GUILDMAGE" )
  filter:AddCardName( "BANT_BATTLEMAGE" )
  filter:AddCardName( "BEAST_WALKERS" )
  filter:AddCardName( "CALDERA_KAVU" )
  filter:AddCardName( "CETA_DISCIPLE" )
  filter:AddCardName( "CIVIC_GUILDMAGE" )
  filter:AddCardName( "CROWN_OF_CONVERGENCE" )
  filter:AddCardName( "EARTHEN_GOO" )
  filter:AddCardName( "ELF_REPLICA" )
  filter:AddCardName( "EVOLUTION_VAT" )
  filter:AddCardName( "FIREBRAND_RANGER" )
  filter:AddCardName( "FRILLED_OCULUS" )
  filter:AddCardName( "GHORCLAN_BLOODSCALE" )
  filter:AddCardName( "GOLGARI_KEYRUNE" )
  filter:AddCardName( "GRUUL_KEYRUNE" )
  filter:AddCardName( "GRUUL_WAR_PLOW" )
  filter:AddCardName( "HEARTWOOD_SHARD" )
  filter:AddCardName( "HORIZON_SPELLBOMB" )
  filter:AddCardName( "HORNED_HELM" )
  filter:AddCardName( "INSATIABLE_SOULEATER" )
  filter:AddCardName( "JUND_BATTLEMAGE" )
  filter:AddCardName( "KELDON_MANTLE" )
  filter:AddCardName( "KNIGHT_OF_THE_SKYWARD_EYE" )
  filter:AddCardName( "LIFESPARK_SPELLBOMB" )
  filter:AddCardName( "LIVING_AIRSHIP" )
  filter:AddCardName( "MALACHITE_GOLEM" )
  filter:AddCardName( "MORTIPEDE" )
  filter:AddCardName( "NACATL_HUNTPRIDE" )
  filter:AddCardName( "NECRA_DISCIPLE" )
  filter:AddCardName( "PLAGUE_BOILER" )
  filter:AddCardName( "ORCISH_HEALER" )
  filter:AddCardName( "PRIZED_ELEPHANT" )
  filter:AddCardName( "QUAGMIRE_DRUID" )
  filter:AddCardName( "RAMPANT_ELEPHANT" )
  filter:AddCardName( "ROCKCASTER_PLATOON" )
  filter:AddCardName( "SELESNYA_KEYRUNE" )
  filter:AddCardName( "SELESNYA_SENTRY" )
  filter:AddCardName( "SILKWING_SCOUT" )
  filter:AddCardName( "SIMIC_KEYRUNE" )
  filter:AddCardName( "SUNSCAPE_APPRENTICE" )
  filter:AddCardName( "SUNSCAPE_MASTER" )
  filter:AddCardName( "SYLVOK_REPLICA" )
  filter:AddCardName( "TANGLE_HULK" )
  filter:AddCardName( "THORNTHRASH_VIASHINO" )
  filter:AddCardName( "THUNDERSCAPE_APPRENTICE" )
  filter:AddCardName( "THUNDERSCAPE_MASTER" )
  filter:AddCardName( "TRIGON_OF_INFESTATION" )
  filter:AddCardName( "VIASHINO_GRAPPLER" )
  filter:AddCardName( "VIASHINO_SLAUGHTERMASTER" )
  filter:AddCardName( "VOTARY_OF_THE_CONCLAVE" )
  filter:AddCardName( "WALL_OF_TANGLECORD" )
  filter:AddCardName( "WEATHERSEED_TOTEM" )
  filter:AddCardName( "ALCHEMISTS_REFUGE" )
  filter:AddCardName( "CENTAUR_GARDEN" )
  filter:AddCardName( "CONTESTED_CLIFFS" )
  filter:AddCardName( "FIRELIT_THICKET" )
  filter:AddCardName( "FLOODED_GROVE" )
  filter:AddCardName( "GAVONY_TOWNSHIP" )
  filter:AddCardName( "GRIM_BACKWOODS" )
  filter:AddCardName( "GROVE_OF_THE_GUARDIAN" )
  filter:AddCardName( "KESSIG_WOLF_RUN" )
  filter:AddCardName( "MOSSWORT_BRIDGE" )
  filter:AddCardName( "NANTUKO_MONASTERY" )
  filter:AddCardName( "NOVIJEN_HEART_OF_PROGRESS" )
  filter:AddCardName( "OKINA_TEMPLE_TO_THE_GRANDFATHERS" )
  filter:AddCardName( "RAGING_RAVINE" )
  filter:AddCardName( "SAPSEEP_FOREST" )
  filter:AddCardName( "SKARRG_THE_RAGE_PITS" )
  filter:AddCardName( "STIRRING_WILDWOOD" )
  filter:AddCardName( "SVOGTHOS_THE_RESTLESS_TOMB" )
  filter:AddCardName( "TREETOP_VILLAGE" )
  filter:AddCardName( "TWILIGHT_MIRE" )
  filter:AddCardName( "VITUGHAZI_THE_CITYTREE" )
  filter:AddCardName( "WOODED_BASTION" )
  filter:AddCardName( "YAVIMAYA_HOLLOW" )
  return filter:CountStopAt( 1 )
end

GreenColourInstead = function()
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone( ZONE_ANYWHERE )
  filter:SetPlayer( Object():GetPlayer() )
  filter:AddCardName( "ANCIENT_GRUDGE" )
  filter:AddCardName( "BENALISH_EMISSARY" )
  filter:AddCardName( "CETAVOLVER" )
  filter:AddCardName( "DEADLY_ALLURE" )
  filter:AddCardName( "MEMORYS_JOURNEY" )
  filter:AddCardName( "NECRAVOLVER" )
  filter:AddCardName( "PLAXMANTA" )
  filter:AddCardName( "PRIMITIVE_JUSTICE" )
  filter:AddCardName( "RAY_OF_REVELATION" )
  filter:AddCardName( "RESOUNDING_SILENCE" )
  filter:AddCardName( "RESOUNDING_THUNDER" )
  filter:AddCardName( "SAVAGE_OFFENSIVE" )
  filter:AddCardName( "SEED_SPARK" )
  filter:AddCardName( "SUNSCAPE_BATTLEMAGE" )
  filter:AddCardName( "THUNDERSCAPE_BATTLEMAGE" )
  filter:AddCardName( "TIN_STREET_HOOLIGAN" )
  filter:AddCardName( "VIGOR_MORTIS" )
  filter:AddCardName( "TRANQUIL_THICKET" )
  return filter:CountStopAt( 1 )
end

FiveColourInsteadInPlay = function()
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone( ZONE_IN_PLAY )
  filter:SetPlayer( Object():GetPlayer() )
  filter:AddCardName( "DOOR_TO_NOTHINGNESS" )
  filter:AddCardName( "DRAGONSOUL_KNIGHT" )
  filter:AddCardName( "ETCHED_MONSTROSITY" )
  filter:AddCardName( "FIST_OF_SUNS" )
  filter:AddCardName( "FLESHFORMER" )
  filter:AddCardName( "LEGACY_WEAPON" )
  filter:AddCardName( "OBELISK_OF_ALARA" )
  filter:AddCardName( "PARAGON_OF_THE_AMESHA" )
  return filter:CountStopAt( 1 )
end

FiveColourInstead = function()
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone( ZONE_ANYWHERE )
  filter:SetPlayer( Object():GetPlayer() )
  filter:AddCardName( "BRINGER_OF_THE_BLACK_DAWN" )
  filter:AddCardName( "BRINGER_OF_THE_BLUE_DAWN" )
  filter:AddCardName( "BRINGER_OF_THE_GREEN_DAWN" )
  filter:AddCardName( "BRINGER_OF_THE_RED_DAWN" )
  filter:AddCardName( "BRINGER_OF_THE_WHITE_DAWN" )
  filter:AddCardName( "WORLDHEART_PHOENIX" )
  return filter:CountStopAt( 1 )
end

CountWhiteColour = function()
  local count = WhiteColourInsteadInPlay() + WhiteColourInstead()
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone( ZONE_ANYWHERE )
  filter:AddColour ( COLOUR_WHITE )
  filter:SetPlayer( Object():GetPlayer() )
  return count + filter:CountStopAt( 1 )
end

CountBlueColour = function()
  local count = BlueColourInsteadInPlay() + BlueColourInstead() + BlueColourInsteadOpponent()
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone( ZONE_ANYWHERE )
  filter:AddColour ( COLOUR_BLUE )
  filter:SetPlayer( Object():GetPlayer() )
  return count + filter:CountStopAt( 1 )
end

CountBlackColour = function()
  local count = BlackColourInsteadInPlay() + BlackColourInstead()
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone( ZONE_ANYWHERE )
  filter:AddColour ( COLOUR_BLACK )
  filter:SetPlayer( Object():GetPlayer() )
  return count + filter:CountStopAt( 1 )
end

CountRedColour = function()
  local count = RedColourInsteadInPlay() + RedColourInstead() + RedColourInsteadOpponent() + RedColourInsteadPlane()
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone( ZONE_ANYWHERE )
  filter:AddColour ( COLOUR_RED )
  filter:SetPlayer( Object():GetPlayer() )
  return count + filter:CountStopAt( 1 )
end

CountGreenColour = function()
  local count = GreenColourInsteadInPlay() + GreenColourInstead()
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone( ZONE_ANYWHERE )
  filter:AddColour ( COLOUR_GREEN )
  filter:SetPlayer( Object():GetPlayer() )
  return count + filter:CountStopAt( 1 )
end

BeCountedAsAllColour = function()
  local count = FiveColourInsteadInPlay() + FiveColourInstead()
  return count
end

NotHaveColourInGame = function(colour_f, colour_s)
  local count = {}
	if BeCountedAsAllColour() == 0 then
    count[1] = CountWhiteColour()
    count[2] = CountBlueColour()
    count[3] = CountBlackColour()
    count[4] = CountRedColour()
    count[5] = CountGreenColour()
    for i=1,5 do
		  if i ~= colour_f and i ~= colour_s and count[i] == 0 then
        return i
		  end
		end
  end
  return 0
end